#include "keyboard_syscalls.h"
#include "keyboard.hpp"

#define LCD_WIDTH_PX 384 
#define LCD_HEIGHT_PX 216
#define MASK_RED 0xf800

void CopySpriteMasked(const char*data, int x, int y, int width, int height, int maskcolor);
int PRGM_GetKey(void);

void CopySpriteMasked(const char*data, int x, int y, int width, int height, int maskcolor) { 
   char* VRAM = (char*)0xA8000000; 
   VRAM += 2*(LCD_WIDTH_PX*y + x); 
   for(int j=y; j<y+height; j++) { 
      for(int i=x; i<x+width;  i++) { 
         if ((((((int)(*data))&0x000000FF)<<8) | ((((int)(*(data+1))))&0x000000FF)) != maskcolor) { 
            *(VRAM++) = *(data++); 
            *(VRAM++) = *(data++); 
         } else { VRAM += 2; data += 2; } 
      } 
      VRAM += 2*(LCD_WIDTH_PX-width); 
   } 
}

int PRGM_GetKey(){ 
	unsigned char buffer[12]; 
	PRGM_GetKey_OS( buffer ); 
	return ( buffer[1] & 0x0F ) * 10 + ( ( buffer[2] & 0xF0 ) >> 4 ); 
}